diff --git a/yumcommands.py b/yumcommands.py
index 4dcbea7..b610f3a 100644
--- a/yumcommands.py
+++ b/yumcommands.py
@@ -13,6 +13,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 # Copyright 2006 Duke University 
+# Copyright 2013 Red Hat
 # Written by Seth Vidal
 
 """
@@ -20,18 +21,26 @@ Classes for subcommands of the yum command line interface.
 """
 
 import os
+import sys
 import cli
+import rpm
 from yum import logginglevels
-from yum import _
+from yum import _, P_
 from yum import misc
 import yum.Errors
 import operator
 import locale
 import fnmatch
 import time
-from yum.i18n import utf8_width, utf8_width_fill, to_unicode
+from yum.i18n import utf8_width, utf8_width_fill, to_unicode, exception2msg
+import tempfile
+import shutil
+import distutils.spawn
+import glob
+import errno
 
 import yum.config
+from yum import updateinfo
 
 def _err_mini_usage(base, basecmd):
     if basecmd not in base.yum_cli_commands:
@@ -43,16 +52,24 @@ def _err_mini_usage(base, basecmd):
     base.logger.critical(txt)
 
 def checkRootUID(base):
-    """
-    Verify that the program is being run by the root user.
+    """Verify that the program is being run by the root user.
 
-    @param base: a YumBase object.
+    :param base: a :class:`yum.Yumbase` object.
+    :raises: :class:`cli.CliError`
     """
     if base.conf.uid != 0:
         base.logger.critical(_('You need to be root to perform this command.'))
         raise cli.CliError
 
 def checkGPGKey(base):
+    """Verify that there are gpg keys for the enabled repositories in the
+    rpm database.
+
+    :param base: a :class:`yum.Yumbase` object.
+    :raises: :class:`cli.CliError`
+    """
+    if base._override_sigchecks:
+        return
     if not base.gpgKeyCheck():
         for repo in base.repos.listEnabled():
             if (repo.gpgcheck or repo.repo_gpgcheck) and not repo.gpgkey:
@@ -75,31 +92,117 @@ For more information contact your distribution or package provider.
                 raise cli.CliError
 
 def checkPackageArg(base, basecmd, extcmds):
+    """Verify that *extcmds* contains the name of at least one package for
+    *basecmd* to act on.
+
+    :param base: a :class:`yum.Yumbase` object.
+    :param basecmd: the name of the command being checked for
+    :param extcmds: a list of arguments passed to *basecmd*
+    :raises: :class:`cli.CliError`
+    """
     if len(extcmds) == 0:
         base.logger.critical(
                 _('Error: Need to pass a list of pkgs to %s') % basecmd)
         _err_mini_usage(base, basecmd)
         raise cli.CliError
 
+def checkSwapPackageArg(base, basecmd, extcmds):
+    """Verify that *extcmds* contains the name of at least two packages for
+    *basecmd* to act on.
+
+    :param base: a :class:`yum.Yumbase` object.
+    :param basecmd: the name of the command being checked for
+    :param extcmds: a list of arguments passed to *basecmd*
+    :raises: :class:`cli.CliError`
+    """
+    min_args = 2
+    if '--' in extcmds:
+        min_args = 3
+    if len(extcmds) < min_args:
+        base.logger.critical(
+                _('Error: Need at least two packages to %s') % basecmd)
+        _err_mini_usage(base, basecmd)
+        raise cli.CliError
+
+def checkRepoPackageArg(base, basecmd, extcmds):
+    """Verify that *extcmds* contains the name of at least one package for
+    *basecmd* to act on.
+
+    :param base: a :class:`yum.Yumbase` object.
+    :param basecmd: the name of the command being checked for
+    :param extcmds: a list of arguments passed to *basecmd*
+    :raises: :class:`cli.CliError`
+    """
+    repos = base.repos.findRepos(extcmds[0], name_match=True, ignore_case=True)
+    if not repos:
+        base.logger.critical(
+                _('Error: Need to pass a single valid repoid. to %s') % basecmd)
+        _err_mini_usage(base, basecmd)
+        raise cli.CliError
+
+    if len(repos) > 1:
+        repos = [r for r in repos if r.isEnabled()]
+
+    if len(repos) > 1:
+        repos = ", ".join([r.ui_id for r in repos])
+        base.logger.critical(
+                _('Error: Need to pass only a single valid repoid. to %s, passed: %s') % (basecmd, repos))
+        _err_mini_usage(base, basecmd)
+        raise cli.CliError
+    if not repos[0].isEnabled():
+        # Might as well just fix this...
+        base.repos.enableRepo(repos[0].id)
+        base.verbose_logger.info(
+                _('Repo %s has been automatically enabled.') % repos[0].ui_id)
+    return repos[0].id
+
+
 def checkItemArg(base, basecmd, extcmds):
+    """Verify that *extcmds* contains the name of at least one item for
+    *basecmd* to act on.  Generally, the items are command-line
+    arguments that are not the name of a package, such as a file name
+    passed to provides.
+
+    :param base: a :class:`yum.Yumbase` object.
+    :param basecmd: the name of the command being checked for
+    :param extcmds: a list of arguments passed to *basecmd*
+    :raises: :class:`cli.CliError`
+    """
     if len(extcmds) == 0:
         base.logger.critical(_('Error: Need an item to match'))
         _err_mini_usage(base, basecmd)
         raise cli.CliError
 
 def checkGroupArg(base, basecmd, extcmds):
+    """Verify that *extcmds* contains the name of at least one group for
+    *basecmd* to act on.
+
+    :param base: a :class:`yum.Yumbase` object.
+    :param basecmd: the name of the command being checked for
+    :param extcmds: a list of arguments passed to *basecmd*
+    :raises: :class:`cli.CliError`
+    """
     if len(extcmds) == 0:
         base.logger.critical(_('Error: Need a group or list of groups'))
         _err_mini_usage(base, basecmd)
         raise cli.CliError    
 
 def checkCleanArg(base, basecmd, extcmds):
+    """Verify that *extcmds* contains at least one argument, and that all
+    arguments in *extcmds* are valid options for clean.
+
+    :param base: a :class:`yum.Yumbase` object
+    :param basecmd: the name of the command being checked for
+    :param extcmds: a list of arguments passed to *basecmd*
+    :raises: :class:`cli.CliError`
+    """
     VALID_ARGS = ('headers', 'packages', 'metadata', 'dbcache', 'plugins',
                   'expire-cache', 'rpmdb', 'all')
 
     if len(extcmds) == 0:
         base.logger.critical(_('Error: clean requires an option: %s') % (
             ", ".join(VALID_ARGS)))
+        raise cli.CliError
 
     for cmd in extcmds:
         if cmd not in VALID_ARGS:
@@ -108,12 +211,14 @@ def checkCleanArg(base, basecmd, extcmds):
             raise cli.CliError
 
 def checkShellArg(base, basecmd, extcmds):
-    """
-    Verify that the arguments given to 'yum shell' are valid.
-
-    yum shell can be given either no args, or exactly one argument,
-    which is the name of a file. If these are not met,
-    raise cli.CliError.
+    """Verify that the arguments given to 'yum shell' are valid.  yum
+    shell can be given either no argument, or exactly one argument,
+    which is the name of a file.
+
+    :param base: a :class:`yum.Yumbase` object.
+    :param basecmd: the name of the command being checked for
+    :param extcmds: a list of arguments passed to *basecmd*
+    :raises: :class:`cli.CliError`
     """
     if len(extcmds) == 0:
         base.verbose_logger.debug(_("No argument to shell"))
@@ -133,10 +238,12 @@ def checkShellArg(base, basecmd, extcmds):
         raise cli.CliError
 
 def checkEnabledRepo(base, possible_local_files=[]):
-    """
-    Verify that there is at least one enabled repo.
+    """Verify that there is at least one enabled repo.
 
-    @param base: a YumBase object.
+    :param base: a :class:`yum.Yumbase` object.
+    :param basecmd: the name of the command being checked for
+    :param extcmds: a list of arguments passed to *basecmd*
+    :raises: :class:`cli.CliError`:
     """
     if base.repos.listEnabled():
         return
@@ -145,6 +252,11 @@ def checkEnabledRepo(base, possible_local_files=[]):
         if lfile.endswith(".rpm") and os.path.exists(lfile):
             return
 
+    # runs prereposetup (which "most" plugins currently use to add repos.)
+    base.pkgSack
+    if base.repos.listEnabled():
+        return
+
     msg = _('There are no enabled repos.\n'
             ' Run "yum repolist all" to see the repos you have.\n'
             ' You can enable repos with yum-config-manager --enable <repo>')
@@ -152,113 +264,296 @@ def checkEnabledRepo(base, possible_local_files=[]):
     raise cli.CliError
 
 class YumCommand:
-        
+    """An abstract base class that defines the methods needed by the cli
+    to execute a specific command.  Subclasses must override at least
+    :func:`getUsage` and :func:`getSummary`.
+    """
+
     def __init__(self):
         self.done_command_once = False
         self.hidden = False
 
     def doneCommand(self, base, msg, *args):
+        """ Output *msg* the first time that this method is called, and do
+        nothing on subsequent calls.  This is to prevent duplicate
+        messages from being printed for the same command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param msg: the message to be output
+        :param *args: additional arguments associated with the message
+        """
         if not self.done_command_once:
-            base.verbose_logger.info(msg, *args)
+            base.verbose_logger.info(logginglevels.INFO_2, msg, *args)
         self.done_command_once = True
 
     def getNames(self):
+        """Return a list of strings that are the names of the command.
+        The command can be called from the command line by using any
+        of these names.
+
+        :return: a list containing the names of the command
+        """
         return []
 
     def getUsage(self):
-        """
-        @return: A usage string for the command, including arguments.
+        """Return a usage string for the command, including arguments.
+
+        :return: a usage string for the command
         """
         raise NotImplementedError
 
     def getSummary(self):
-        """
-        @return: A one line summary of what the command does.
+        """Return a one line summary of what the command does.
+
+        :return: a one line summary of what the command does
         """
         raise NotImplementedError
     
     def doCheck(self, base, basecmd, extcmds):
+        """Verify that various conditions are met so that the command
+        can run.
+
+        :param base: a :class:`yum.Yumbase` object.
+        :param basecmd: the name of the command being checked for
+        :param extcmds: a list of arguments passed to *basecmd*
+        """
         pass
 
     def doCommand(self, base, basecmd, extcmds):
-        """
-        @return: (exit_code, [ errors ]) where exit_code is:
-           0 = we're done, exit
-           1 = we've errored, exit with error string
-           2 = we've got work yet to do, onto the next stage
+        """Execute the command
+
+        :param base: a :class:`yum.Yumbase` object.
+        :param basecmd: the name of the command being executed
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
         """
         return 0, [_('Nothing to do')]
     
     def needTs(self, base, basecmd, extcmds):
+        """Return whether a transaction set must be set up before the
+        command can run
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: True if a transaction set is needed, False otherwise
+        """
         return True
+
+    #  Some of this is subjective, esp. between past/present, but roughly use:
+    #
+    # write = I'm using package data to alter the rpmdb in anyway.
+    # read-only:future  = I'm providing data that is likely to result in a
+    #                     future write, so we might as well do it now.
+    #                     Eg. yum check-update && yum update -q -y
+    # read-only:present = I'm providing data about the present state of
+    #                     packages in the repo.
+    #                     Eg. yum list yum
+    # read-only:past    = I'm providing context data about past writes, or just
+    #                     anything that is available is good enough for me
+    #                     (speed is much better than quality).
+    #                     Eg. yum history info
+    #                     Eg. TAB completion
+    #
+    # ...default is write, which does the same thing we always did (obey
+    # metadata_expire and live with it).
+    def cacheRequirement(self, base, basecmd, extcmds):
+        """Return the cache requirements for the remote repos.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: Type of requirement: read-only:past, read-only:present, read-only:future, write
+        """
+        return 'write'
         
+
 class InstallCommand(YumCommand):
+    """A class containing methods needed by the cli to execute the
+    install command.
+    """
+
     def getNames(self):
-        return ['install']
+        """Return a list containing the names of this command.  This
+        command can be called from the command line by using any of
+        these names.
+
+        :return: a list containing the names of this command
+        """
+        return ['install', 'install-n', 'install-na', 'install-nevra']
 
     def getUsage(self):
+        """Return a usage string for this command.
+
+        :return: a usage string for this command
+        """
         return _("PACKAGE...")
 
     def getSummary(self):
+        """Return a one line summary of this command.
+
+        :return: a one line summary of this command
+        """
         return _("Install a package or packages on your system")
     
     def doCheck(self, base, basecmd, extcmds):
+        """Verify that conditions are met so that this command can run.
+        These include that the program is being run by the root user,
+        that there are enabled repositories with gpg keys, and that
+        this command is called with appropriate arguments.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        """
         checkRootUID(base)
         checkGPGKey(base)
         checkPackageArg(base, basecmd, extcmds)
         checkEnabledRepo(base, extcmds)
 
     def doCommand(self, base, basecmd, extcmds):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         self.doneCommand(base, _("Setting up Install Process"))
-        try:
-            return base.installPkgs(extcmds)
-        except yum.Errors.YumBaseError, e:
-            return 1, [str(e)]
+        return base.installPkgs(extcmds, basecmd=basecmd)
+
 
 class UpdateCommand(YumCommand):
+    """A class containing methods needed by the cli to execute the
+    update command.
+    """
+
     def getNames(self):
+        """Return a list containing the names of this command.  This
+        command can by called from the command line by using any of
+        these names.
+
+        :return: a list containing the names of this command
+        """
         return ['update', 'update-to']
 
     def getUsage(self):
+        """Return a usage string for this command.
+
+        :return: a usage string for this command
+        """
         return _("[PACKAGE...]")
 
     def getSummary(self):
+        """Return a one line summary of this command.
+
+        :return: a one line summary of this command
+        """
         return _("Update a package or packages on your system")
 
     def doCheck(self, base, basecmd, extcmds):
+        """Verify that conditions are met so that this command can run.
+        These include that there are enabled repositories with gpg
+        keys, and that this command is being run by the root user.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        """
         checkRootUID(base)
         checkGPGKey(base)
         checkEnabledRepo(base, extcmds)
 
     def doCommand(self, base, basecmd, extcmds):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         self.doneCommand(base, _("Setting up Update Process"))
-        try:
-            return base.updatePkgs(extcmds, update_to=(basecmd == 'update-to'))
-        except yum.Errors.YumBaseError, e:
-            return 1, [str(e)]
+        ret = base.updatePkgs(extcmds, update_to=(basecmd == 'update-to'))
+        updateinfo.remove_txmbrs(base)
+        return ret
 
 class DistroSyncCommand(YumCommand):
+    """A class containing methods needed by the cli to execute the
+    distro-synch command.
+    """
+
     def getNames(self):
-        return ['distribution-synchronization', 'distro-sync']
+        """Return a list containing the names of this command.  This
+        command can be called from the command line by using any of these names.
+
+        :return: a list containing the names of this command
+        """
+        return ['distribution-synchronization', 'distro-sync', 'distupgrade']
 
     def getUsage(self):
+        """Return a usage string for this command.
+
+        :return: a usage string for this command
+        """
         return _("[PACKAGE...]")
 
     def getSummary(self):
+        """Return a one line summary of this command.
+
+        :return: a one line summary of this command
+        """
         return _("Synchronize installed packages to the latest available versions")
 
     def doCheck(self, base, basecmd, extcmds):
+        """Verify that conditions are met so that this command can run.
+        These include that the program is being run by the root user,
+        and that there are enabled repositories with gpg keys.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        """
         checkRootUID(base)
         checkGPGKey(base)
         checkEnabledRepo(base, extcmds)
 
     def doCommand(self, base, basecmd, extcmds):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         self.doneCommand(base, _("Setting up Distribution Synchronization Process"))
-        try:
-            base.conf.obsoletes = 1
-            return base.distroSyncPkgs(extcmds)
-        except yum.Errors.YumBaseError, e:
-            return 1, [str(e)]
+        base.conf.obsoletes = 1
+        ret = base.distroSyncPkgs(extcmds)
+        updateinfo.remove_txmbrs(base)
+        return ret
 
 def _add_pkg_simple_list_lens(data, pkg, indent=''):
     """ Get the length of each pkg's column. Add that to data.
@@ -289,22 +584,62 @@ def _list_cmd_calc_columns(base, ypl):
     return (-columns[0], -columns[1], -columns[2])
 
 class InfoCommand(YumCommand):
+    """A class containing methods needed by the cli to execute the
+    info command.
+    """
+
     def getNames(self):
+        """Return a list containing the names of this command.  This
+        command can be called from the command line by using any of these names.
+
+        :return: a list containing the names of this command
+        """
         return ['info']
 
     def getUsage(self):
-        return "[PACKAGE|all|available|installed|updates|extras|obsoletes|recent]"
+        """Return a usage string for this command.
+
+        :return: a usage string for this command
+        """
+        return "[PACKAGE|all|available|installed|updates|distro-extras|extras|obsoletes|recent]"
 
     def getSummary(self):
+        """Return a one line summary of this command.
+
+        :return: a one line summary of this command
+        """
         return _("Display details about a package or group of packages")
 
-    def doCommand(self, base, basecmd, extcmds):
-        try:
-            highlight = base.term.MODE['bold']
-            ypl = base.returnPkgLists(extcmds, installed_available=highlight)
-        except yum.Errors.YumBaseError, e:
-            return 1, [str(e)]
+    def doCommand(self, base, basecmd, extcmds, repoid=None):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
+
+        if extcmds and extcmds[0] in ('updates', 'obsoletes'):
+            updateinfo.exclude_updates(base)
         else:
+            updateinfo.exclude_all(base)
+
+        if True: # Try, YumBase...
+            highlight = base.term.MODE['bold']
+            #  If we are doing: "yum info installed blah" don't do the highlight
+            # because the usability of not accessing the repos. is still higher
+            # than providing colour for a single line. Usable updatesd/etc. FTW.
+            if basecmd == 'info' and extcmds and extcmds[0] == 'installed':
+                highlight = False
+            ypl = base.returnPkgLists(extcmds, installed_available=highlight,
+                                      repoid=repoid)
+
             update_pkgs = {}
             inst_pkgs   = {}
             local_pkgs  = {}
@@ -341,6 +676,7 @@ class InfoCommand(YumCommand):
                         local_pkgs[(po.name, po.arch)] = po
 
             # Output the packages:
+            kern = base.conf.color_list_installed_running_kernel
             clio = base.conf.color_list_installed_older
             clin = base.conf.color_list_installed_newer
             clir = base.conf.color_list_installed_reinstall
@@ -348,7 +684,9 @@ class InfoCommand(YumCommand):
             rip = base.listPkgs(ypl.installed, _('Installed Packages'), basecmd,
                                 highlight_na=update_pkgs, columns=columns,
                                 highlight_modes={'>' : clio, '<' : clin,
+                                                 'kern' : kern,
                                                  '=' : clir, 'not in' : clie})
+            kern = base.conf.color_list_available_running_kernel
             clau = base.conf.color_list_available_upgrade
             clad = base.conf.color_list_available_downgrade
             clar = base.conf.color_list_available_reinstall
@@ -356,6 +694,7 @@ class InfoCommand(YumCommand):
             rap = base.listPkgs(ypl.available, _('Available Packages'), basecmd,
                                 highlight_na=inst_pkgs, columns=columns,
                                 highlight_modes={'<' : clau, '>' : clad,
+                                                 'kern' : kern,
                                                  '=' : clar, 'not in' : clai})
             rep = base.listPkgs(ypl.extras, _('Extra Packages'), basecmd,
                                 columns=columns)
@@ -374,7 +713,7 @@ class InfoCommand(YumCommand):
                 for obtup in sorted(ypl.obsoletesTuples,
                                     key=operator.itemgetter(0)):
                     base.updatesObsoletesList(obtup, 'obsoletes',
-                                              columns=columns)
+                                              columns=columns, repoid=repoid)
             else:
                 rop = base.listPkgs(ypl.obsoletes, _('Obsoleting Packages'),
                                     basecmd, columns=columns)
